/**
 * Called when the round ends in favor of a team or a draw.
 *
 * @param team			The winning team.
 * 0 = Winner: draw.
 * 1 = Winner: terrorist team.
 * 2 = Winner: counter-terrorist team.
 */
 enum HnsTeams
 {
    HNS_DRAW,
    HNS_TEAM_T,
    HNS_TEAM_CT
 };
 
 forward hns_round_end(HnsTeams:team);

/**
 * Called at the end of the timer when the CT start acting.
 */
 forward hns_round_start(bool:no_loner);
 
/**
 * Called the duration of the timer. 
 * The feature is useful for creating an informer with a count.
 *
 * @param index         Client index.
 * @param time          Timer seconds.
 */
 forward hns_timer_process(index, time);
 
/**
 * Called when the CT becomes TT
 * thanks to the change of command (native hns_switch_teams()).
 *
 * @param index         Client index.
 */
 forward hns_became_terrorist(index);
 
/**
 * Called when a player from a certain 
 * team is become lonely (;D).
 *
 * @param index         Client index.
 * @param team          Player team.
 */
 forward hns_player_loner(index, HnsTeams:team);

/**
 * The function needs to change the teams interchanged.
 */
 native hns_switch_teams();